## ros-indigo-stream-manipulator-3d 0.1.7

=== CMakeLists.txt ===
# Software License Agreement (BSD License)
#
#   Stream Manipulator 3d - https://github.com/3DVision-Stack/stream-manipulator-3D
#   Copyright (c) 2016, Federico Spinelli (fspinelli@gmail.com)
#   All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright notice, this
#   list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright notice,
#   this list of conditions and the following disclaimer in the documentation
#   and/or other materials provided with the distribution.
#
# * Neither the name of the copyright holder(s) nor the names of its
#   contributors may be used to endorse or promote products derived from
#   this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# Project top level cmake
cmake_minimum_required(VERSION 2.8.11)
project(stream_manipulator_3d)

################################################################################
########## Lets find everything we need  #######################################
################################################################################
##Find Catkin macros and libraries
find_package(catkin REQUIRED COMPONENTS
  geometry_msgs
  pluginlib
  pcl_conversions
  roscpp
  roslib
  rosconsole
  pcl_ros
  sensor_msgs
  visualization_msgs
  cmake_modules
  tf
  )
#Find Boost
find_package(Boost REQUIRED)
#Find PCL
find_package(PCL REQUIRED)
add_definitions(${PCL_DEFINITIONS})
link_directories(${PCL_LIBRARY_DIRS})
##Eigen
find_package(Eigen REQUIRED)
#include a bunch of dirs to search path
include_directories(include
                    ${catkin_INCLUDE_DIRS}
                    )
include_directories(SYSTEM
                    ${Eigen_INCLUDE_DIRS}
                    ${Boost_INCLUDE_DIR}
                    ${PCL_INCLUDE_DIRS}
                    )


################################################################################
####### Set the project sources ################################################
################################################################################
set(SOURCES
    src/common_ros.cpp
    src/main.cpp
    src/stream_manipulator.cpp
    )
################################################################################
########### Start doing things. Add all filters ################################
################################################################################
add_library(filter_plugins
    src/filters/cropbox.cpp
    include/stream_manipulator_3d/filters/cropbox.hpp
    src/filters/voxel_grid.cpp
    include/stream_manipulator_3d/filters/voxel_grid.hpp
    src/filters/frustum.cpp
    include/stream_manipulator_3d/filters/frustum.hpp
    src/filters/median.cpp
    include/stream_manipulator_3d/filters/median.hpp
    src/filters/passthrough.cpp
    include/stream_manipulator_3d/filters/passthrough.hpp
    src/filters/statistical_outlier.cpp
    include/stream_manipulator_3d/filters/statistical_outlier.hpp
    src/filters/radius_outlier.cpp
    include/stream_manipulator_3d/filters/radius_outlier.hpp
    )
target_link_libraries(filter_plugins ${catkin_LIBRARIES} ${PCL_LIBRARIES} ${Boost_LIBRARIES} rt)

################################################################################
########### Add Outputs ########################################################
################################################################################
add_library(output_plugins
    src/output/publisher.cpp
    include/stream_manipulator_3d/output/publisher.hpp
    )
target_link_libraries(output_plugins ${catkin_LIBRARIES} ${Boost_LIBRARIES} rt)
################################################################################
#### Export project and libraries through catkin ###############################
################################################################################
##Catkin specific configuration:
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES
    filter_plugins
    output_plugins
  CATKIN_DEPENDS
    geometry_msgs
    pcl_conversions
    pluginlib
    roscpp
    rosconsole
    roslib
    pcl_ros
    sensor_msgs
    visualization_msgs
    cmake_modules
    message_runtime
    tf
  DEPENDS
    Boost
    Eigen
    PCL
)
################################################################################
####################### Now Build the project ##################################
################################################################################

add_executable(stream_manipulator_3d ${SOURCES})

#add those ros geneated headers
#add_dependencies(stream_manipulator_3d
#  stream_manipulator_3d_generate_messages_cpp
#  )

target_link_libraries(stream_manipulator_3d
    ${catkin_LIBRARIES}
    ${PCL_LIBRARIES}
    ${Boost_LIBRARIES}
    ${Eigen_LIBRARIES}
    rt
)
################################################################################
######################### Install ##############################################
################################################################################

install(TARGETS stream_manipulator_3d filter_plugins output_plugins
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

## Mark cpp header files for installation
install(DIRECTORY include/stream_manipulator_3d/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

## Mark other files for installation (e.g. launch and bag files, etc.)
install(FILES plugins.xml sm3d.rviz default_config.yaml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

install(DIRECTORY launch/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch)
########################################################################## DONE!

=== debian/changelog ===
ros-indigo-stream-manipulator-3d (0.1.7-0trusty) trusty; urgency=high

  * Updates & Bugfixes
    Bugfix: CropBox not updating Translation properly
    Add Pause/Resume functionality:
    - Pause button will block processing and all plugins, it also
    unsubscribe from input_topic.
    - Resume will resubscribe and resume all normal functionality.
    - While stream_manipulator_3d is paused you cannot modify configuration
    or plugin specific settings
    Add Saving/Loading configuration functionality:
    - Saving config to rosparams and then dumpng to yaml file
    - Loading yaml file into rosparams, then update configuration from them.
  * Add two more filter plugins
    * Add Statistical Outlier Removal Plugin
    Wrapping  of  pcl::StatisticalOutlierRemoval  filter.  StatisticalOutlierRemoval
    uses  point  neighborhood  statistics  to filter  outlier  data.  The  algorithm
    iterates through  the entire  input twice:  During the  first iteration  it will
    compute the average distance that each point has to its nearest k neighbors. The
    value of k  can be set using  nr_k_neighbors param. Next, the  mean and standard
    deviation of all  these distances are computed in order  to determine a distance
    threshold. The distance threshold will be equal to: mean + stddev_mult * stddev.
    The multiplier  for the  standard deviation can  be set  using stddev_multiplier
    parameter. During the next iteration the  points will be classified as inlier or
    outlier if  their average  neighbor distance  is below  or above  this threshold
    respectively. Outliers will then be removed from the stream. The neighbors found
    for each query point will be found amongst ALL input points.
    * Add Radius Outlier Removal Plugin
    Wrapping  of  pcl::RadiusOutlierRemoval   filter.  RadiusOutlierRemoval  filters
    points in a cloud  based on the number of neighbors  they have. Iterates through
    the entire  input once, and  for each point,  retrieves the number  of neighbors
    within a certain radius.  The point will be considered an outlier  if it has too
    few neighbors, as determined by  k_neighbors_threshold parameter. The radius can
    be changed using  radius_search param. The neighbors found for  each query point
    will be found amongst ALL points of input stream.
  * Contributors: Federico Spinelli

 -- Tabjones <fspinelli@gmail.com>  Wed, 03 Aug 2016 22:00:00 -0000

ros-indigo-stream-manipulator-3d (0.1.6-0trusty) trusty; urgency=high

  * Add some more Plugins:
    * Frustum Culling Filter Plugin
    Removes everything inside/outside a frustum,  defined by two aperture angles and
    two parallel planes.
    * Median Filter Plugin
    The  median filter  is  one of  the simplest  and  wide-spread image  processing
    filters. It is known to perform  well with "shot"/impulse noise (some individual
    pixels having extreme  values), it does not reduce contrast  across steps in the
    function  (as compared  to filters  based  on averaging),  and it  is robust  to
    outliers. Furthermore, it is simple to implement and efficient, as it requires a
    single pass over  the image. It consists  of a moving window of  fixed size that
    replaces the pixel in the center with the median inside the window.
    NOTE: This filters  only the depth (z-component) of  organized and untransformed
    (i.e., in  camera coordinates) point  clouds. An error  will be outputted  if an
    unorganized cloud is given.
    * PassThrough Filter Plugin
    PassThrough passes  points in a  cloud based  on constraints for  one particular
    field of the  point type. Iterates through the entire  input once, automatically
    filtering non-finite points and the points outside the interval specified by the
    filter limits, which applies only to the field specified by field type.
  * Contributors: Federico Spinelli

 -- Tabjones <fspinelli@gmail.com>  Thu, 28 Jul 2016 22:00:00 -0000

ros-indigo-stream-manipulator-3d (0.1.4-0trusty) trusty; urgency=high

  * Fix build errors
    Add proper catkin dependencies
  * Contributors: Federico Spinelli

 -- Tabjones <fspinelli@gmail.com>  Fri, 22 Jul 2016 22:00:00 -0000

ros-indigo-stream-manipulator-3d (0.1.2-0trusty) trusty; urgency=high



 -- Tabjones <fspinelli@gmail.com>  Thu, 21 Jul 2016 22:00:00 -0000

ros-indigo-stream-manipulator-3d (0.1.1-0trusty) trusty; urgency=high



 -- Tabjones <fspinelli@gmail.com>  Tue, 19 Jul 2016 22:00:00 -0000

ros-indigo-stream-manipulator-3d (0.1.0-0trusty) trusty; urgency=high



 -- Tabjones <fspinelli@gmail.com>  Wed, 06 Apr 2016 22:00:00 -0000

=== debian/control ===
Source: ros-indigo-stream-manipulator-3d
Section: misc
Priority: extra
Maintainer: Tabjones <fspinelli@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-catkin, ros-indigo-cmake-modules, ros-indigo-geometry-msgs, ros-indigo-pcl-conversions, ros-indigo-pcl-ros, ros-indigo-pluginlib, ros-indigo-rosconsole, ros-indigo-roscpp, ros-indigo-roslib, ros-indigo-sensor-msgs, ros-indigo-tf, ros-indigo-visualization-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-indigo-stream-manipulator-3d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-cmake-modules, ros-indigo-geometry-msgs, ros-indigo-message-runtime, ros-indigo-pcl-conversions, ros-indigo-pcl-ros, ros-indigo-pluginlib, ros-indigo-rosconsole, ros-indigo-roscpp, ros-indigo-roslib, ros-indigo-sensor-msgs, ros-indigo-tf, ros-indigo-visualization-msgs
Description: Stream Manipulator 3D let's you subscribe to a stream of point clouds, such as those coming from sensors, and manipulate it online, republishing the modified streams.
 Input stream can be modified by applying various filters, in the order you choose.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-stream-manipulator-3d//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
